data dynamic_leads (drop=_:) ; 
  if _n_=1 then do; 
    if 0 then set sales (keep=product sales month 
              rename=(product=_PL sales=_SL month=_ML)); 
              
    declare hash leads (dataset:'SALES (keep=PRODUCT MONTH SALES rename=(PRODUCT=_PL MONTH=_ML SALES=_SL)',ordered:'A') ; 
      leads.definekey('_PL','_ML'); 
      leads.definedata('_PL','_ML','_SL'); 
      leads.definedone(); 
    declare hiter li ('leads'); 
  end; 
  
  set sales ; 
  li.setcur(key:PRODUCT,key:MONTH); /* Point hash iterator at item for current product/month */
  _rc=li.next();       /* Advance one item in the hash object */
  if _rc=0 and _PL=PRODUCT then changerate=(_SL-sales)/(_ML-month); 
 run; 


