data irregular_leads2 (drop=_: label='1, 2, & 3 period leads for products A, B, C, and D');
  set sales;
 
  select (product);

    when ('A') do _I=1 to ifn(lag(product) =' ',3,1);
      if eofa=0 then set sales (where=(product='A') firstobs=2
              keep=product sales rename=(sales=LEAD3))  end=eofa;
      else lead3=. ;
      LEAD2=lag(lead3);
      LEAD1=lag2(lead3);
    end;

    when ('B') do _I=1 to ifn(lag(product) =' ',3,1);
      if eofb=0 then set sales (where=(product='B') firstobs=2
              keep=product sales rename=(sales=LEAD3))  end=eofb;
      else lead3=. ;
      lead2=lag(lead3);
      lead1=lag2(lead3);
    end;

    when ('C') do _I=1 to ifn(lag(product) =' ',3,1);
      if eofc=0 then set sales (where=(product='C') firstobs=2
              keep=product sales rename=(sales=LEAD3))  end=eofc;
      else lead3=. ;
      lead2=lag(lead3);
      lead1=lag2(lead3);
    end;

    when ('D') do _I=1 to ifn(lag(product) =' ',3,1);
      if eofd=0 then set sales (where=(product='D') firstobs=2
              keep=product sales rename=(sales=LEAD3))  end=eofd;
      else lead3=. ;
      lead2=lag(lead3);
      lead1=lag2(lead3);
    end;

    otherwise lead3=. ;
  end;

run;